import setuptools
from glob import glob

__package_name__ = "kaml"
__version__ = "0.1"

with open("README.md", "r", encoding="utf-8") as fh:
    description = fh.read()
    
with open('requirements.txt') as f:
    required = f.read().splitlines()

with open('requirementsTS.txt') as f:
    required_ts = f.read().splitlines()

with open('requirementsDL.txt') as f:
    required_dl = f.read().splitlines()

setuptools.setup(
    name=__package_name__,
    version=__version__,
    license='MIT',
    author="Katonic",
    author_email="support@katonic.ai",
    description="katonic enterprise-ready model automation",
    long_description=description,
    long_description_content_type="text/markdown",
    # entry_points={"console_scripts": ["katflow=katflow.cli:katflow"]},
    packages=setuptools.find_packages(
        exclude=(
            "datasets",
            "examples",
            "notes",
            "docker",
            "notebooks"
            )
        ),
    include_package_data=True,
    python_requires='>=3.7, <4',
    install_requires = required,
    extras_require={
        "ts" : required_ts,
        "dl" : required_dl
    }
)